use serde::Deserialize;

#[derive(Deserialize, Debug, Clone)]
#[non_exhaustive]
pub struct TrackObject {
    pub album: Option<AlbumObject>,
    pub artists: Option<Vec<ArtistObject>>,
    pub href: String,
    pub id: String,
    pub name: String,
    pub uri: Uri,
}

#[derive(Deserialize, Debug, Clone)]
#[non_exhaustive]
pub struct AlbumObject {
    pub album_type: String,
    pub total_tracks: u32,
    pub href: String,
    pub id: String,
    pub name: String,
    pub release_date: String,
    pub uri: Uri,
    pub genres: Option<String>,

}

#[derive(Deserialize, Debug, Clone)]
#[non_exhaustive]
pub struct ArtistObject {
    pub href: String,
    pub id: String,
    pub name: String,
}

#[derive(Deserialize, Debug, Clone)]
pub struct Uri(pub String);
