use sqlx::{MySqlPool, mysql::MySqlQueryResult};
use crate::spotify_types::*;

#[allow(non_snake_case)] // Fixes warning for macro
pub async fn even_allocation(pool: &MySqlPool) -> Result<Vec<Uri>, sqlx::Error> {
    let users: Vec<u32> = sqlx::query!("
        SELECT UserId From Users
        ")
        .fetch_all(pool)
        .await?
        .iter()
        .map(|row| row.UserId)
        .collect();

    let mut uris: Vec<Uri> = Vec::new();
    let num: u32 = (100 / users.len()) as u32;
    for user in users {
        let mut uri_list: Vec<Uri> = sqlx::query!("
            SELECT Uri FROM Tracks
            WHERE UserId = ?
            ORDER BY RAND()
            LIMIT ?
            ", user, num)
            .fetch_all(pool)
            .await?
            .iter()
            .map(|row| Uri(row.Uri.clone()))
            .collect();
        uris.append(&mut uri_list);
    }

    Ok(uris)
}
